FIX::UtcTimeStamp Class Reference
User

Date and Time represented in UTC. More...

`#include <FieldTypes.h>`

Inheritance diagram for FIX::UtcTimeStamp:
[legend]
Collaboration diagram for FIX::UtcTimeStamp:
[legend]

## Public Member Functions

| UtcTimeStamp ()
| Defaults to the current date and time. More...
| UtcTimeStamp (int hour, int minute, int second, int millisecond=0)
| Defaults to the current date. More...
| UtcTimeStamp (int hour, int minute, int second, int fraction, int precision)
| UtcTimeStamp (int hour, int minute, int second, int date, int month, int year)
| UtcTimeStamp (int hour, int minute, int second, int millisecond, int date, int month, int year)
| UtcTimeStamp (int hour, int minute, int second, int fraction, int date, int month, int year, int precision)
| UtcTimeStamp (time_t time, int millisecond=0)
| UtcTimeStamp (time_t time, int fraction, int precision)
| UtcTimeStamp (const tm *time, int millisecond=0)
| UtcTimeStamp (const tm *time, int fraction, int precision)
void | setCurrent ()
Public Member Functions inherited from FIX::DateTime
| DateTime ()
| Default constructor - initializes to zero. More...
| DateTime (int date, int64_t time)
| Construct from a Julian day number and time in millis. More...
| DateTime (int year, int month, int day, int hour, int minute, int second, int millis)
| Construct from the specified components. More...
| DateTime (int year, int month, int day, int hour, int minute, int second, int fraction, int precision)
| Construct from the specified components. More...
virtual | ~DateTime ()
int | getYear () const
| Return the year portion of the date. More...
int | getMonth () const
| Return the month (1-12) portion of the date. More...
int | getDay () const
| Return the day of the month portion of the date. More...
int | getDate () const
| Another name for the day of the month. More...
int | getJulianDate () const
| Return the internal julian date. More...
int | getHour () const
| Return the hour portion of the time (0-23) More...
int | getMinute () const
| Return the minute portion of the time (0-59) More...
int | getSecond () const
| Return the second portion of the time (0-59) More...
int | getMillisecond () const
| Return the millisecond portion of the time (0-999) More...
int | getMicroecond () const
| Return the microsecond portion of the time. More...
unsigned int | getNanosecond () const
| Return the nanosecond portion of the time. More...
int | getFraction (int precision) const
| Return the fraction portion of the time. More...
void | getYMD (int &year, int &month, int &day) const
| Load the referenced values with the year, month and day portions of the date in a single operation. More...
void | getHMS (int &hour, int &minute, int &second, int &millis) const
| Load the referenced values with the hour, minute, second and millisecond portions of the time in a single operation. More...
void | getHMS (int &hour, int &minute, int &second, int &fraction, int precision) const
| Load the referenced values with the hour, minute, second and fraction portions of the time in a single operation. More...
int | getWeekDay () const
| Calculate the weekday of the date (Sunday is 1, Saturday is 7) More...
time_t | getTimeT () const
| Convert the DateTime to a time_t. More...
tm | getTmUtc () const
| Convert the DateTime to a struct tm which is in UTC. More...
void | setYMD (int year, int month, int day)
| Set the date portion of the DateTime. More...
void | setHMS (int hour, int minute, int second, int millis)
| Set the time portion of the DateTime. More...
void | setHMS (int hour, int minute, int second, int fraction, int precision)
| Set the time portion of the DateTime. More...
void | setHour (int hour)
| Set the hour portion of the time. More...
void | setMinute (int min)
| Set the minute portion of the time. More...
void | setSecond (int sec)
| Set the seconds portion of the time. More...
void | setMillisecond (int millis)
| Set the millisecond portion of the time. More...
void | setMicrosecond (int micros)
| Set the microsecond portion of the time. More...
void | setNanosecond (int nanos)
| Set the nanosecond portion of the time. More...
void | setFraction (int fraction, int precision)
| Set the fraction portion of the time. More...
void | clearDate ()
| Clear the date portion of the DateTime. More...
void | clearTime ()
| Clear the time portion of the DateTime. More...
void | set (int date, int64_t time)
| Set the internal date and time members. More...
void | set (const DateTime &other)
| Initialize from another DateTime. More...
void | operator+= (int seconds)
| Add a number of seconds to this. More...

## Additional Inherited Members

Static Public Member Functions inherited from FIX::DateTime
static int | convertToNanos (int fraction, int precision)
| Convert to internal nanos. More...
static int64_t | makeHMS (int hour, int minute, int second, int nanos)
| Helper method to convert a broken down time to a number of nanoseconds since midnight. More...
static DateTime | nowUtc ()
| Return the current wall-clock time as a utc DateTime. More...
static DateTime | nowLocal ()
| Return the current wall-clock time as a local DateTime. More...
static DateTime | fromUtcTimeT (time_t t, int millis=0)
| Convert a time_t and optional milliseconds to a DateTime. More...
static DateTime | fromLocalTimeT (time_t t, int millis=0)
static DateTime | fromUtcTimeT (time_t t, int fraction, int precision)
static DateTime | fromLocalTimeT (time_t t, int fraction, int precision)
static DateTime | fromTm (const tm &tm, int millis=0)
| Convert a tm and optional milliseconds to a DateTime. More...
static DateTime | fromTm (const tm &tm, int fraction, int precision)
| Convert a tm and optional milliseconds to a DateTime. More...
static int | julianDate (int year, int month, int day)
| Helper method to calculate a Julian day number. More...
static void | getYMD (int jday, int &year, int &month, int &day)
| Convert a Julian day number to a year, month and day. More...
Public Attributes inherited from FIX::DateTime
int | m_date
int64_t | m_time
Static Public Attributes inherited from FIX::DateTime
static const int64_t | SECONDS_PER_DAY = 86400
| Magic numbers. More...
static const int64_t | SECONDS_PER_HOUR = 3600
static const int64_t | SECONDS_PER_MIN = 60
static const int64_t | MINUTES_PER_HOUR = 60
static const int64_t | NANOS_PER_DAY = 86400000000000
static const int64_t | NANOS_PER_HOUR = 3600000000000
static const int64_t | NANOS_PER_MIN = 60000000000
static const int64_t | NANOS_PER_SEC = 1000000000
static const int64_t | JULIAN_19700101 = 2440588

## Detailed Description

Date and Time represented in UTC.

Definition at line 582 of file FieldTypes.h.

## Constructor & Destructor Documentation

## UtcTimeStamp() [1/10]

FIX::UtcTimeStamp::UtcTimeStamp | ( |  | ) |

inline

Defaults to the current date and time.

Definition at line 586 of file FieldTypes.h.

: DateTime( DateTime::nowUtc() ) {}
FIX::DateTime::DateTime
DateTime()
Default constructor - initializes to zero.
Definition: FieldTypes.h:80
FIX::DateTime::nowUtc
static DateTime nowUtc()
Return the current wall-clock time as a utc DateTime.
Definition: FieldTypes.cpp:34

## UtcTimeStamp() [2/10]

FIX::UtcTimeStamp::UtcTimeStamp | ( | int | hour,
|  | int | minute,
|  | int | second,
|  | int | millisecond = `0`
| ) |  |

inline

Defaults to the current date.

Definition at line 590 of file FieldTypes.h.

: DateTime( DateTime::nowUtc() )
{
setHMS( hour, minute, second, millisecond );
}
FIX::DateTime::setHMS
void setHMS(int hour, int minute, int second, int millis)
Set the time portion of the DateTime.
Definition: FieldTypes.h:288

References FIX::DateTime::setHMS().

## UtcTimeStamp() [3/10]

FIX::UtcTimeStamp::UtcTimeStamp | ( | int | hour,
|  | int | minute,
|  | int | second,
|  | int | fraction,
|  | int | precision
| ) |  |

inline

Definition at line 596 of file FieldTypes.h.

: DateTime( DateTime::nowUtc() )
{
setHMS( hour, minute, second, fraction, precision );
}

References FIX::DateTime::setHMS().

## UtcTimeStamp() [4/10]

FIX::UtcTimeStamp::UtcTimeStamp | ( | int | hour,
|  | int | minute,
|  | int | second,
|  | int | date,
|  | int | month,
|  | int | year
| ) |  |

inline

Definition at line 602 of file FieldTypes.h.

: DateTime( year, month, date, hour, minute, second, 0 ) {}

## UtcTimeStamp() [5/10]

FIX::UtcTimeStamp::UtcTimeStamp | ( | int | hour,
|  | int | minute,
|  | int | second,
|  | int | millisecond,
|  | int | date,
|  | int | month,
|  | int | year
| ) |  |

inline

Definition at line 606 of file FieldTypes.h.

: DateTime( year, month, date, hour, minute, second, millisecond ) {}

## UtcTimeStamp() [6/10]

FIX::UtcTimeStamp::UtcTimeStamp | ( | int | hour,
|  | int | minute,
|  | int | second,
|  | int | fraction,
|  | int | date,
|  | int | month,
|  | int | year,
|  | int | precision
| ) |  |

inline

Definition at line 610 of file FieldTypes.h.

: DateTime( year, month, date, hour, minute, second, fraction, precision ) {}

## UtcTimeStamp() [7/10]

FIX::UtcTimeStamp::UtcTimeStamp | ( | time_t | time,
|  | int | millisecond = `0`
| ) |  |

inline explicit

Definition at line 614 of file FieldTypes.h.

: DateTime( fromUtcTimeT (time, millisecond) ) {}
FIX::DateTime::fromUtcTimeT
static DateTime fromUtcTimeT(time_t t, int millis=0)
Convert a time_t and optional milliseconds to a DateTime.
Definition: FieldTypes.h:468

## UtcTimeStamp() [8/10]

FIX::UtcTimeStamp::UtcTimeStamp | ( | time_t | time,
|  | int | fraction,
|  | int | precision
| ) |  |

inline

Definition at line 617 of file FieldTypes.h.

: DateTime( fromUtcTimeT (time, fraction, precision) ) {}

## UtcTimeStamp() [9/10]

FIX::UtcTimeStamp::UtcTimeStamp | ( | const tm * | time,
|  | int | millisecond = `0`
| ) |  |

inline

Definition at line 620 of file FieldTypes.h.

: DateTime( fromTm (*time, millisecond) ) {}
FIX::DateTime::fromTm
static DateTime fromTm(const tm &tm, int millis=0)
Convert a tm and optional milliseconds to a DateTime.
Definition: FieldTypes.h:494

## UtcTimeStamp() [10/10]

FIX::UtcTimeStamp::UtcTimeStamp | ( | const tm * | time,
|  | int | fraction,
|  | int | precision
| ) |  |

inline

Definition at line 623 of file FieldTypes.h.

: DateTime( fromTm (*time, fraction, precision) ) {}

## Member Function Documentation

## setCurrent()

void FIX::UtcTimeStamp::setCurrent | ( |  | ) |

inline

Definition at line 626 of file FieldTypes.h.

{
set( DateTime::nowUtc() );
}
FIX::DateTime::set
void set(int date, int64_t time)
Set the internal date and time members.
Definition: FieldTypes.h:370

References FIX::DateTime::nowUtc(), and FIX::DateTime::set().

Referenced by FIX::ScreenLog::onEvent(), FIX::ScreenLog::onIncoming(), FIX::ScreenLog::onOutgoing(), and FIX::NullStore::reset().

The documentation for this class was generated from the following file:

- FieldTypes.h